## deepin-pw-check 5.0.13

=== Makefile ===

PREFIX=/usr
GOPKG_PREFIX = service
GOBUILD = go build $(GO_BUILD_FLAGS)
ifeq (${PAM_MODULE_DIR},)
PAM_MODULE_DIR := /etc/pam.d
endif
ifeq (${PKG_FILE_DIR},)
PKG_FILE_DIR := /usr/local/lib/pkgconfig
endif
BINARIES = deepin-pw-check
LIBRARIES = libdeepin_pw_check.so.1.1
LINK_LIBRARIES = libdeepin_pw_check.so
PAM_MODULE = pam_deepin_pw_check.so
LANGUAGES = $(basename $(notdir $(wildcard misc/po/*.po)))
SRCS_C = $(basename $(shell cd unit_test; ls *.c))
LIBSRCS_C = $(basename $(shell cd lib; ls *.c))
TOOL_BINARAY = pwd-conf-update

all: build

prepare:
	@mkdir -p out/bin

out/bin/%: prepare
	env GOPATH="${GOPATH}" ${GOBUILD} -o $@  ${GOPKG_PREFIX}/*.go

out/${LIBRARIES}:
	gcc lib/*.c -fPIC -shared -lcrypt -lcrack -liniparser -DIN_CRACKLIB -z noexecstack -Wl,-soname,libdeepin_pw_check.so.1 -o $@ $^
	cd out; ln -s ${LIBRARIES} ${LINK_LIBRARIES}

lib/%:
	gcc $(addsuffix .c, $@) -c -DIN_CRACKLIB -z noexecstack -o $(addsuffix .o, $@)

link: $(addprefix lib/, ${LIBSRCS_C})
	# cd lib ;ar x /usr/lib/$(DEB_HOST_MULTIARCH)/libiniparser.a
	# cd lib ;ar x /usr/lib/$(DEB_HOST_MULTIARCH)/libcrack.a
	# cd lib ;ar x /usr/lib/$(DEB_HOST_MULTIARCH)/libcrypt.a
	ar rcs out/libdeepin_pw_check.a lib/*.o

static_lib: link

out/${PAM_MODULE}: out/${LIBRARIES}
	gcc pam/*.c -fPIC -shared -lpam -L./out/ -ldeepin_pw_check -o $@ $^

build_tool: prepare
	gcc tool/*.c -liniparser -o out/${TOOL_BINARAY}

build: prepare $(addprefix out/bin/, ${BINARIES}) out/${LIBRARIES} static_lib out/${PAM_MODULE} build_tool ts_to_policy

install: translate
	mkdir -pv ${DESTDIR}${PREFIX}/share/locale
	- cp -rf out/locale/* ${DESTDIR}${PREFIX}/share/locale
	mkdir -p ${DESTDIR}${PREFIX}/lib
	cp -f out/lib* ${DESTDIR}${PREFIX}/lib
	mkdir -p ${DESTDIR}${PREFIX}/include
	cp lib/deepin_pw_check.h ${DESTDIR}${PREFIX}/include/
	mkdir -pv ${DESTDIR}/${PKG_FILE_DIR}
	cp misc/pkgconfig/libdeepin_pw_check.pc ${DESTDIR}/${PKG_FILE_DIR}
	mkdir -pv ${DESTDIR}/${PAM_MODULE_DIR}
	cp out/${PAM_MODULE} ${DESTDIR}/${PAM_MODULE_DIR}
	mkdir -pv ${DESTDIR}${PREFIX}/bin/
	cp out/${TOOL_BINARAY} ${DESTDIR}${PREFIX}/bin/${TOOL_BINARAY}
	mkdir -p ${DESTDIR}${PREFIX}/share/dbus-1/system.d
	cp misc/conf/*.conf ${DESTDIR}${PREFIX}/share/dbus-1/system.d/
	mkdir -pv ${DESTDIR}${PREFIX}/share/dbus-1
	cp -r misc/system-services ${DESTDIR}${PREFIX}/share/dbus-1/
	mkdir -p ${DESTDIR}${PREFIX}/lib/deepin-pw-check/
	cp out/bin/deepin-pw-check ${DESTDIR}${PREFIX}/lib/deepin-pw-check/
	mkdir -p ${DESTDIR}${PREFIX}/share/polkit-1/actions
	cp -r misc/polkit-action/*.policy ${DESTDIR}${PREFIX}/share/polkit-1/actions

test: $(addprefix unit_test/, $(SRCS_C)) clean_test

unit_test/%:
	gcc $(addsuffix .c, $@) ./lib/*.c -lcrypt -lcrack -liniparser -DIN_CRACKLIB -z noexecstack -o $@
	@chmod +x $@
	@./$@

clean:
	rm -rf out
	rm -rf lib/*.o

clean_test: $(addprefix unit_test/, $(SRCS_C))
	rm -f $^

pot:
	xgettext --from-code utf-8 lib/* -o misc/po/deepin-pw-check.pot

POLICY_NAME = com.deepin.daemon.passwdconf

ts:
	deepin-policy-ts-convert policy2ts misc/polkit-action/$(POLICY_NAME).policy.in misc/ts/$(POLICY_NAME).policy

ts_to_policy:
	deepin-policy-ts-convert ts2policy misc/polkit-action/$(POLICY_NAME).policy.in misc/ts/$(POLICY_NAME).policy misc/polkit-action/$(POLICY_NAME).policy

out/locale/%/LC_MESSAGES/deepin-pw-check.mo: misc/po/%.po
	mkdir -p $(@D)
	msgfmt -o $@ $<

translate: $(addsuffix /LC_MESSAGES/deepin-pw-check.mo, $(addprefix out/locale/, ${LANGUAGES}))

=== debian/changelog ===
deepin-pw-check (5.0.13-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 14 Apr 2021 15:28:37 +0800

deepin-pw-check (1.0.0.1) unstable; urgency=medium

  * Initial release.

 -- xiejiabo <xiejiabo@uniontech.com>  Wed, 18 Nov 2020 17:58:35 +0800

## deepin-pw-check 5.1.8

=== Makefile ===
--- 
+++ 
@@ -17,6 +17,8 @@
 LIBSRCS_C = $(basename $(shell cd lib; ls *.c))
 TOOL_BINARAY = pwd-conf-update
 
+SECURITY_BUILD_OPTIONS = -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy
+
 all: build
 
 prepare:
@@ -26,11 +28,11 @@
 	env GOPATH="${GOPATH}" ${GOBUILD} -o $@  ${GOPKG_PREFIX}/*.go
 
 out/${LIBRARIES}:
-	gcc lib/*.c -fPIC -shared -lcrypt -lcrack -liniparser -DIN_CRACKLIB -z noexecstack -Wl,-soname,libdeepin_pw_check.so.1 -o $@ $^
+	gcc lib/*.c ${SECURITY_BUILD_OPTIONS} -shared -DIN_CRACKLIB -W -Wall -Wl,-soname,libdeepin_pw_check.so.1 -o $@ $^ -lcrypt -lcrack -liniparser
 	cd out; ln -s ${LIBRARIES} ${LINK_LIBRARIES}
 
 lib/%:
-	gcc $(addsuffix .c, $@) -c -DIN_CRACKLIB -z noexecstack -o $(addsuffix .o, $@)
+	gcc $(addsuffix .c, $@) -c ${SECURITY_BUILD_OPTIONS} -DIN_CRACKLIB -W -Wall -o $(addsuffix .o, $@)
 
 link: $(addprefix lib/, ${LIBSRCS_C})
 	# cd lib ;ar x /usr/lib/$(DEB_HOST_MULTIARCH)/libiniparser.a
@@ -41,10 +43,10 @@
 static_lib: link
 
 out/${PAM_MODULE}: out/${LIBRARIES}
-	gcc pam/*.c -fPIC -shared -lpam -L./out/ -ldeepin_pw_check -o $@ $^
+	gcc pam/*.c -fPIC -W -Wall -shared -lpam -L./out/ -ldeepin_pw_check -o $@ $^
 
 build_tool: prepare
-	gcc tool/*.c -liniparser -o out/${TOOL_BINARAY}
+	gcc tool/*.c -liniparser -W -Wall -o out/${TOOL_BINARAY}
 
 build: prepare $(addprefix out/bin/, ${BINARIES}) out/${LIBRARIES} static_lib out/${PAM_MODULE} build_tool ts_to_policy
 
@@ -73,7 +75,7 @@
 test: $(addprefix unit_test/, $(SRCS_C)) clean_test
 
 unit_test/%:
-	gcc $(addsuffix .c, $@) ./lib/*.c -lcrypt -lcrack -liniparser -DIN_CRACKLIB -z noexecstack -o $@
+	gcc $(addsuffix .c, $@) ./lib/*.c -lcrypt -lcrack -liniparser -DIN_CRACKLIB -W -Wall -DPASSWD_CONF_FILE_GRUB2=\"unit_test/testdata/grub2_edit_auth.conf\" -z noexecstack -o $@
 	@chmod +x $@
 	@./$@
 
@@ -85,7 +87,7 @@
 	rm -f $^
 
 pot:
-	xgettext --from-code utf-8 lib/* -o misc/po/deepin-pw-check.pot
+	xgettext --from-code utf-8 lib/*.c pam/*.c -o misc/po/deepin-pw-check.pot
 
 POLICY_NAME = com.deepin.daemon.passwdconf

=== debian/changelog ===
deepin-pw-check (5.1.8-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 21 Feb 2022 11:04:49 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# DH_VERBOSE = 1

export GOPATH = /usr/share/gocode
export PAM_MODULE_DIR = usr/lib/$(DEB_HOST_MULTIARCH)/security
export PKG_FILE_DIR = usr/lib/pkgconfig
export GO111MODULE = off
export GOCACHE=/tmp/

%:
	dh $@

override_dh_link:
	dh_link -plibdeepin-pw-check-dev usr/lib/libdeepin_pw_check.so.1 \
		usr/lib/libdeepin_pw_check.so
	dh_link -plibdeepin-pw-check usr/lib/libdeepin_pw_check.so.1.1 \
		usr/lib/libdeepin_pw_check.so.1

## deepin-pw-check 5.1.12

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 LIBSRCS_C = $(basename $(shell cd lib; ls *.c))
 TOOL_BINARAY = pwd-conf-update
 
-SECURITY_BUILD_OPTIONS = -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy
+SECURITY_BUILD_OPTIONS = -fPIC -fstack-protector-all -z relro -z noexecstack -z now -pie
 
 all: build
 
@@ -25,7 +25,7 @@
 	@mkdir -p out/bin
 
 out/bin/%: prepare
-	env GOPATH="${GOPATH}" ${GOBUILD} -o $@  ${GOPKG_PREFIX}/*.go
+	env GOPATH="${GOPATH}" ${GOBUILD} -o $@ ${GOBUILD_OPTIONS} ${GOPKG_PREFIX}/*.go
 
 out/${LIBRARIES}:
 	gcc lib/*.c ${SECURITY_BUILD_OPTIONS} -shared -DIN_CRACKLIB -W -Wall -Wl,-soname,libdeepin_pw_check.so.1 -o $@ $^ -lcrypt -lcrack -liniparser
@@ -46,7 +46,7 @@
 	gcc pam/*.c -fPIC -W -Wall -shared -lpam -L./out/ -ldeepin_pw_check -o $@ $^
 
 build_tool: prepare
-	gcc tool/*.c -liniparser -W -Wall -o out/${TOOL_BINARAY}
+	gcc tool/*.c -liniparser -W -Wall ${SECURITY_BUILD_OPTIONS} -o out/${TOOL_BINARAY}
 
 build: prepare $(addprefix out/bin/, ${BINARIES}) out/${LIBRARIES} static_lib out/${PAM_MODULE} build_tool ts_to_policy

=== debian/changelog ===
deepin-pw-check (5.1.12-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 27 Jun 2022 11:10:28 +0800

=== debian/control ===
Source: deepin-pw-check
Section: devel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper (>= 9),
 libcrack2-dev,
 libpam-dev,
 libiniparser-dev,
 golang-go,
 golang-github-linuxdeepin-go-lib-dev,
 golang-dbus-dev,
 golang-github-linuxdeepin-go-dbus-factory-dev,
 cracklib-runtime,
 deepin-gettext-tools,
Standards-Version: 4.1.4
Homepage: http://www.deepin.org

Package: deepin-pw-check
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 policykit-1,
Description: deepin password check interface
 deepin-pw-check is a tool to verify the validity of the password

Package: libdeepin-pw-check
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 cracklib-runtime,
 libcrack2,
 libiniparser1,
Breaks: libpam-cracklib
Replaces: libpam-cracklib
Description: deepin password check interface
 deepin-pw-check is a tool to verify the validity of the password

Package: libdeepin-pw-check-dev
Architecture: any
Depends: libdeepin-pw-check, ${misc:Depends}, ${shlibs:Depends},
Description: deepin password check interface
 deepin-pw-check is a tool to verify the validity of the password

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,10 @@
 export GO111MODULE = off
 export GOCACHE=/tmp/
 
+ifneq ($(DEB_BUILD_ARCH), mips64el)
+	export GOBUILD_OPTIONS=-ldflags '-linkmode=external -extldflags "-pie"'
+endif
+
 %:
 	dh $@

## deepin-pw-check 5.1.16

=== debian/changelog ===
deepin-pw-check (5.1.16-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 15 Aug 2022 21:53:52 +0800

## deepin-pw-check 5.1.17

=== debian/changelog ===
deepin-pw-check (5.1.17-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 13 Oct 2022 14:07:37 +0800

## deepin-pw-check 6.0.2

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
-
 PREFIX=/usr
-GOPKG_PREFIX = service
+GOPKG_PREFIX = github.com/linuxdeepin/deepin-pw-check
 GOBUILD = go build $(GO_BUILD_FLAGS)
+GOBUILD_DIR = gobuild
 ifeq (${PAM_MODULE_DIR},)
 PAM_MODULE_DIR := /etc/pam.d
 endif
@@ -18,14 +18,17 @@
 TOOL_BINARAY = pwd-conf-update
 
 SECURITY_BUILD_OPTIONS = -fPIC -fstack-protector-all -z relro -z noexecstack -z now -pie
+export GOPATH = /usr/share/gocode
 
 all: build
 
 prepare:
+	@mkdir -p ${GOBUILD_DIR}/src/$(dir ${GOPKG_PREFIX})
+	@ln -snf ../../../.. ${GOBUILD_DIR}/src/${GOPKG_PREFIX}
 	@mkdir -p out/bin
 
 out/bin/%: prepare
-	env GOPATH="${GOPATH}" ${GOBUILD} -o $@ ${GOBUILD_OPTIONS} ${GOPKG_PREFIX}/*.go
+	env GOPATH="${GOPATH}:${CURDIR}/${GOBUILD_DIR}" ${GOBUILD} -o $@ ${GOBUILD_OPTIONS} ${GOPKG_PREFIX}/service
 
 out/${LIBRARIES}:
 	gcc lib/*.c ${SECURITY_BUILD_OPTIONS} -shared -DIN_CRACKLIB -W -Wall -Wl,-soname,libdeepin_pw_check.so.1 -o $@ $^ -lcrypt -lcrack -liniparser
@@ -89,7 +92,7 @@
 pot:
 	xgettext --from-code utf-8 lib/*.c pam/*.c -o misc/po/deepin-pw-check.pot
 
-POLICY_NAME = com.deepin.daemon.passwdconf
+POLICY_NAME = org.deepin.dde.passwdconf
 
 ts:
 	deepin-policy-ts-convert policy2ts misc/polkit-action/$(POLICY_NAME).policy.in misc/ts/$(POLICY_NAME).policy

=== debian/changelog ===
deepin-pw-check (6.0.2) unstable; urgency=medium

  * chore: support go mod

 -- chenhongtao <chenhongtao@deepin.org>  Sun, 17 Sep 2023 10:45:50 +0800

deepin-pw-check (6.0.1) unstable; urgency=medium

  [ TagBuilder ]
  * feat: 接口更变，增加V23接口(Task: 207483)(Influence: 接口更变)

 -- zhaoyingzhen <zhaoyingzhen@uniontech.com>  Tue, 13 Dec 2022 19:30:08 +0800

deepin-pw-check (6.0.0.0) unstable; urgency=medium

  * release 6.0.0.0

 --  <fanpengcheng@uniontech.com>  Tue, 14 June 2022 17:06:13 +0800

deepin-pw-check (5.1.9) unstable; urgency=medium

  * fix mirror install error.

 -- echengqi <echengqi@uniontech.com>  Fri, 10 jun 2022 13:48:35 +0800

=== debian/control ===
--- 
+++ 
@@ -26,9 +26,6 @@
 Package: libdeepin-pw-check
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends},
- cracklib-runtime,
- libcrack2,
- libiniparser1,
 Breaks: libpam-cracklib
 Replaces: libpam-cracklib
 Description: deepin password check interface

=== debian/rules ===
--- 
+++ 
@@ -3,8 +3,7 @@
 include /usr/share/dpkg/architecture.mk
 
 # DH_VERBOSE = 1
-
-export GOPATH = /usr/share/gocode
+#export GOPATH = /usr/share/gocode
 export PAM_MODULE_DIR = usr/lib/$(DEB_HOST_MULTIARCH)/security
 export PKG_FILE_DIR = usr/lib/pkgconfig
 export GO111MODULE = off

## deepin-pw-check 6.0.3

=== Makefile ===
--- 
+++ 
@@ -74,6 +74,8 @@
 	cp out/bin/deepin-pw-check ${DESTDIR}${PREFIX}/lib/deepin-pw-check/
 	mkdir -p ${DESTDIR}${PREFIX}/share/polkit-1/actions
 	cp -r misc/polkit-action/*.policy ${DESTDIR}${PREFIX}/share/polkit-1/actions
+	mkdir -p ${DESTDIR}/lib/systemd/system
+	cp  misc/systemd-service/deepin-passwd-conf.service ${DESTDIR}/lib/systemd/system/
 
 test: $(addprefix unit_test/, $(SRCS_C)) clean_test

=== debian/changelog ===
deepin-pw-check (6.0.3) UNRELEASED; urgency=medium

  * feat: 对org.deepin.dde.PasswdConf1服务进行安全加固 (#39)

 -- fuleyi <fuleyi@uniontech.com>  Fri, 18 Oct 2024 15:34:01 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Deepin Packages Builder <packages@deepin.com>
 Build-Depends:
- debhelper (>= 9),
+ debhelper-compat (= 11),
  libcrack2-dev,
  libpam-dev,
  libiniparser-dev,
@@ -26,6 +26,7 @@
 Package: libdeepin-pw-check
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends},
+ libpam-runtime
 Breaks: libpam-cracklib
 Replaces: libpam-cracklib
 Description: deepin password check interface

=== debian/rules ===
--- 
+++ 
@@ -21,3 +21,7 @@
 		usr/lib/libdeepin_pw_check.so
 	dh_link -plibdeepin-pw-check usr/lib/libdeepin_pw_check.so.1.1 \
 		usr/lib/libdeepin_pw_check.so.1
+
+override_dh_auto_install:
+	dh_auto_install
+	dh_installtmpfiles deepin-pw-check.tmpfiles
